git-fetch.shon commit git.el: Prepend a slash to the file name when adding to .gitignore. (9f56a7f)
   1#!/bin/sh
   2#
   3
   4USAGE='<fetch-options> <repository> <refspec>...'
   5. git-sh-setup
   6. git-parse-remote
   7_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
   8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
   9
  10LF='
  11'
  12IFS="$LF"
  13
  14rloga=fetch
  15no_tags=
  16tags=
  17append=
  18force=
  19verbose=
  20update_head_ok=
  21exec=
  22upload_pack=
  23keep=--thin
  24while case "$#" in 0) break ;; esac
  25do
  26        case "$1" in
  27        -a|--a|--ap|--app|--appe|--appen|--append)
  28                append=t
  29                ;;
  30        --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
  31        --upload-pa|--upload-pac|--upload-pack)
  32                shift
  33                exec="--exec=$1" 
  34                upload_pack="-u $1"
  35                ;;
  36        -f|--f|--fo|--for|--forc|--force)
  37                force=t
  38                ;;
  39        -t|--t|--ta|--tag|--tags)
  40                tags=t
  41                ;;
  42        -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
  43                no_tags=t
  44                ;;
  45        -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
  46        --update-he|--update-hea|--update-head|--update-head-|\
  47        --update-head-o|--update-head-ok)
  48                update_head_ok=t
  49                ;;
  50        -v|--verbose)
  51                verbose=Yes
  52                ;;
  53        -k|--k|--ke|--kee|--keep)
  54                keep=--keep
  55                ;;
  56        --reflog-action=*)
  57                rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`
  58                ;;
  59        -*)
  60                usage
  61                ;;
  62        *)
  63                break
  64                ;;
  65        esac
  66        shift
  67done
  68
  69case "$#" in
  700)
  71        test -f "$GIT_DIR/branches/origin" ||
  72                test -f "$GIT_DIR/remotes/origin" ||
  73                        die "Where do you want to fetch from today?"
  74        set origin ;;
  75esac
  76
  77remote_nick="$1"
  78remote=$(get_remote_url "$@")
  79refs=
  80rref=
  81rsync_slurped_objects=
  82
  83rloga="$rloga $remote_nick"
  84test "$remote_nick" = "$remote" || rloga="$rloga $remote"
  85
  86if test "" = "$append"
  87then
  88        : >"$GIT_DIR/FETCH_HEAD"
  89fi
  90
  91append_fetch_head () {
  92    head_="$1"
  93    remote_="$2"
  94    remote_name_="$3"
  95    remote_nick_="$4"
  96    local_name_="$5"
  97    case "$6" in
  98    t) not_for_merge_='not-for-merge' ;;
  99    '') not_for_merge_= ;;
 100    esac
 101
 102    # remote-nick is the URL given on the command line (or a shorthand)
 103    # remote-name is the $GIT_DIR relative refs/ path we computed
 104    # for this refspec.
 105
 106    # the $note_ variable will be fed to git-fmt-merge-msg for further
 107    # processing.
 108    case "$remote_name_" in
 109    HEAD)
 110        note_= ;;
 111    refs/heads/*)
 112        note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
 113        note_="branch '$note_' of " ;;
 114    refs/tags/*)
 115        note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
 116        note_="tag '$note_' of " ;;
 117    refs/remotes/*)
 118        note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
 119        note_="remote branch '$note_' of " ;;
 120    *)
 121        note_="$remote_name of " ;;
 122    esac
 123    remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
 124        remote_="$remote_1_"
 125    note_="$note_$remote_"
 126
 127    # 2.6.11-tree tag would not be happy to be fed to resolve.
 128    if git-cat-file commit "$head_" >/dev/null 2>&1
 129    then
 130        headc_=$(git-rev-parse --verify "$head_^0") || exit
 131        echo "$headc_   $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
 132        [ "$verbose" ] && echo >&2 "* committish: $head_"
 133        [ "$verbose" ] && echo >&2 "  $note_"
 134    else
 135        echo "$head_    not-for-merge   $note_" >>"$GIT_DIR/FETCH_HEAD"
 136        [ "$verbose" ] && echo >&2 "* non-commit: $head_"
 137        [ "$verbose" ] && echo >&2 "  $note_"
 138    fi
 139    if test "$local_name_" != ""
 140    then
 141        # We are storing the head locally.  Make sure that it is
 142        # a fast forward (aka "reverse push").
 143        fast_forward_local "$local_name_" "$head_" "$note_"
 144    fi
 145}
 146
 147fast_forward_local () {
 148    mkdir -p "$(dirname "$GIT_DIR/$1")"
 149    case "$1" in
 150    refs/tags/*)
 151        # Tags need not be pointing at commits so there
 152        # is no way to guarantee "fast-forward" anyway.
 153        if test -f "$GIT_DIR/$1"
 154        then
 155                if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
 156                then
 157                        [ "$verbose" ] && echo >&2 "* $1: same as $3" ||:
 158                else
 159                        echo >&2 "* $1: updating with $3"
 160                        git-update-ref -m "$rloga: updating tag" "$1" "$2"
 161                fi
 162        else
 163                echo >&2 "* $1: storing $3"
 164                git-update-ref -m "$rloga: storing tag" "$1" "$2"
 165        fi
 166        ;;
 167
 168    refs/heads/* | refs/remotes/*)
 169        # $1 is the ref being updated.
 170        # $2 is the new value for the ref.
 171        local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
 172        if test "$local"
 173        then
 174            # Require fast-forward.
 175            mb=$(git-merge-base "$local" "$2") &&
 176            case "$2,$mb" in
 177            $local,*)
 178                if test -n "$verbose"
 179                then
 180                        echo >&2 "* $1: same as $3"
 181                fi
 182                ;;
 183            *,$local)
 184                echo >&2 "* $1: fast forward to $3"
 185                echo >&2 "  from $local to $2"
 186                git-update-ref -m "$rloga: fast-forward" "$1" "$2" "$local"
 187                ;;
 188            *)
 189                false
 190                ;;
 191            esac || {
 192                echo >&2 "* $1: does not fast forward to $3;"
 193                case ",$force,$single_force," in
 194                *,t,*)
 195                        echo >&2 "  forcing update."
 196                        git-update-ref -m "$rloga: forced-update" "$1" "$2" "$local"
 197                        ;;
 198                *)
 199                        echo >&2 "  not updating."
 200                        exit 1
 201                        ;;
 202                esac
 203            }
 204        else
 205            echo >&2 "* $1: storing $3"
 206            git-update-ref -m "$rloga: storing head" "$1" "$2"
 207        fi
 208        ;;
 209    esac
 210}
 211
 212case "$update_head_ok" in
 213'')
 214        orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 215        ;;
 216esac
 217
 218# If --tags (and later --heads or --all) is specified, then we are
 219# not talking about defaults stored in Pull: line of remotes or
 220# branches file, and just fetch those and refspecs explicitly given.
 221# Otherwise we do what we always did.
 222
 223reflist=$(get_remote_refs_for_fetch "$@")
 224if test "$tags"
 225then
 226        taglist=`IFS="  " &&
 227                  git-ls-remote $upload_pack --tags "$remote" |
 228                  while read sha1 name
 229                  do
 230                        case "$name" in
 231                        *^*) continue ;;
 232                        esac
 233                        if git-check-ref-format "$name"
 234                        then
 235                            echo ".${name}:${name}"
 236                        else
 237                            echo >&2 "warning: tag ${name} ignored"
 238                        fi
 239                  done`
 240        if test "$#" -gt 1
 241        then
 242                # remote URL plus explicit refspecs; we need to merge them.
 243                reflist="$reflist$LF$taglist"
 244        else
 245                # No explicit refspecs; fetch tags only.
 246                reflist=$taglist
 247        fi
 248fi
 249
 250fetch_main () {
 251  reflist="$1"
 252  refs=
 253
 254  for ref in $reflist
 255  do
 256      refs="$refs$LF$ref"
 257
 258      # These are relative path from $GIT_DIR, typically starting at refs/
 259      # but may be HEAD
 260      if expr "z$ref" : 'z\.' >/dev/null
 261      then
 262          not_for_merge=t
 263          ref=$(expr "z$ref" : 'z\.\(.*\)')
 264      else
 265          not_for_merge=
 266      fi
 267      if expr "z$ref" : 'z+' >/dev/null
 268      then
 269          single_force=t
 270          ref=$(expr "z$ref" : 'z+\(.*\)')
 271      else
 272          single_force=
 273      fi
 274      remote_name=$(expr "z$ref" : 'z\([^:]*\):')
 275      local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
 276
 277      rref="$rref$LF$remote_name"
 278
 279      # There are transports that can fetch only one head at a time...
 280      case "$remote" in
 281      http://* | https://*)
 282          if [ -n "$GIT_SSL_NO_VERIFY" ]; then
 283              curl_extra_args="-k"
 284          fi
 285          max_depth=5
 286          depth=0
 287          head="ref: $remote_name"
 288          while (expr "z$head" : "zref:" && expr $depth \< $max_depth) >/dev/null
 289          do
 290            remote_name_quoted=$(@@PERL@@ -e '
 291              my $u = $ARGV[0];
 292              $u =~ s/^ref:\s*//;
 293              $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
 294              print "$u";
 295          ' "$head")
 296            head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted")
 297            depth=$( expr \( $depth + 1 \) )
 298          done
 299          expr "z$head" : "z$_x40\$" >/dev/null ||
 300              die "Failed to fetch $remote_name from $remote"
 301          echo >&2 Fetching "$remote_name from $remote" using http
 302          git-http-fetch -v -a "$head" "$remote/" || exit
 303          ;;
 304      rsync://*)
 305          TMP_HEAD="$GIT_DIR/TMP_HEAD"
 306          rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
 307          head=$(git-rev-parse --verify TMP_HEAD)
 308          rm -f "$TMP_HEAD"
 309          test "$rsync_slurped_objects" || {
 310              rsync -av --ignore-existing --exclude info \
 311                  "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
 312
 313              # Look at objects/info/alternates for rsync -- http will
 314              # support it natively and git native ones will do it on
 315              # the remote end.  Not having that file is not a crime.
 316              rsync -q "$remote/objects/info/alternates" \
 317                  "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 318                  rm -f "$GIT_DIR/TMP_ALT"
 319              if test -f "$GIT_DIR/TMP_ALT"
 320              then
 321                  resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
 322                  while read alt
 323                  do
 324                      case "$alt" in 'bad alternate: '*) die "$alt";; esac
 325                      echo >&2 "Getting alternate: $alt"
 326                      rsync -av --ignore-existing --exclude info \
 327                      "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
 328                  done
 329                  rm -f "$GIT_DIR/TMP_ALT"
 330              fi
 331              rsync_slurped_objects=t
 332          }
 333          ;;
 334      *)
 335          # We will do git native transport with just one call later.
 336          continue ;;
 337      esac
 338
 339      append_fetch_head "$head" "$remote" \
 340          "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 341
 342  done
 343
 344  case "$remote" in
 345  http://* | https://* | rsync://* )
 346      ;; # we are already done.
 347  *)
 348    ( : subshell because we muck with IFS
 349      IFS="     $LF"
 350      (
 351          git-fetch-pack $exec $keep "$remote" $rref || echo failed "$remote"
 352      ) |
 353      while read sha1 remote_name
 354      do
 355          case "$sha1" in
 356          failed)
 357                  echo >&2 "Fetch failure: $remote"
 358                  exit 1 ;;
 359          esac
 360          found=
 361          single_force=
 362          for ref in $refs
 363          do
 364              case "$ref" in
 365              +$remote_name:*)
 366                  single_force=t
 367                  not_for_merge=
 368                  found="$ref"
 369                  break ;;
 370              .+$remote_name:*)
 371                  single_force=t
 372                  not_for_merge=t
 373                  found="$ref"
 374                  break ;;
 375              .$remote_name:*)
 376                  not_for_merge=t
 377                  found="$ref"
 378                  break ;;
 379              $remote_name:*)
 380                  not_for_merge=
 381                  found="$ref"
 382                  break ;;
 383              esac
 384          done
 385          local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
 386          append_fetch_head "$sha1" "$remote" \
 387                  "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 388      done
 389    ) || exit ;;
 390  esac
 391
 392}
 393
 394fetch_main "$reflist"
 395
 396# automated tag following
 397case "$no_tags$tags" in
 398'')
 399        case "$reflist" in
 400        *:refs/*)
 401                # effective only when we are following remote branch
 402                # using local tracking branch.
 403                taglist=$(IFS=" " &&
 404                git-ls-remote $upload_pack --tags "$remote" |
 405                sed -ne 's|^\([0-9a-f]*\)[      ]\(refs/tags/.*\)^{}$|\1 \2|p' |
 406                while read sha1 name
 407                do
 408                        test -f "$GIT_DIR/$name" && continue
 409                        git-check-ref-format "$name" || {
 410                                echo >&2 "warning: tag ${name} ignored"
 411                                continue
 412                        }
 413                        git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
 414                        echo >&2 "Auto-following $name"
 415                        echo ".${name}:${name}"
 416                done)
 417        esac
 418        case "$taglist" in
 419        '') ;;
 420        ?*)
 421                fetch_main "$taglist" ;;
 422        esac
 423esac
 424
 425# If the original head was empty (i.e. no "master" yet), or
 426# if we were told not to worry, we do not have to check.
 427case ",$update_head_ok,$orig_head," in
 428*,, | t,* )
 429        ;;
 430*)
 431        curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 432        if test "$curr_head" != "$orig_head"
 433        then
 434            git-update-ref \
 435                        -m "$rloga: Undoing incorrectly fetched HEAD." \
 436                        HEAD "$orig_head"
 437                die "Cannot fetch into the current branch."
 438        fi
 439        ;;
 440esac